Subject: Re: [forces] comments #13

From: "Chuanhuang Li" <[email-masked]>
Date: Wed, 17 Aug 2011 15:33:41 +0800

Hi,Jamal

>45)5.4.2.1 technical question
>dont we have something equivalent to ’RedirectIndex’ that the CE
>can use to deduce source LFBs etc for the purpose of maybe multiplexing
>when it receives the redirected packet?
>--------
 I don't think we need such metadata. The reasons are:
1) All associated metadata produced(but not consumed) by previous processed 
LFBs should be delivered to CE. CE can do something according these metadata.
For example, the packet can't find L2 information in EtherEncap and need to be 
redirected CE to do address resolution. Through the value of "ExecptionID" metadata, 
CE knows what he should do.
2)Different FE may have different LFBs and  their topology (They also can have their 
private LFBs). 
3)Only through knowing the upstream LFB, CE can't get enough information to decide 
how to process the packet.
Of course, CE will be difficult to make a decision, if there is no metadata indicating the 
status of the packet(such as ExecptionID). In this case, CE need to  treat it as a new 
packet that havn't get any processing in FE.  

Joel, what's your opinion?

Yours,
Chuanhuang

---

From: Jamal Hadi Salim <[email-masked]>
Date: Wed, 17 Aug 2011 05:07:57 -0400

Chuanhuang,

Ok - makes more sense. But the text leaves this question dangling.
Can you suggest some text to add to clarify this issue?

cheers,
jamal

---

From: "Joel M. Halpern" <[email-masked]>
Date: Wed, 17 Aug 2011 10:30:38 -0400

Basically, I agree with Chuanhuang.

One of the reasons for including certain metadata items we have included
was specifically so that any processing, including the CE, could trace
back as much as it needed.  I have assumed that there was enough for the
CE to figure out all error cases.  I would not add a generic metadatum,
as I don't think we know how it would be filled in.  But if there is a
case where we are missing some information, we should add that.

Yours,
Joel

---

From: Jamal Hadi Salim <[email-masked]>
Date: Wed, 17 Aug 2011 10:43:29 -0400

It seems sufficient - we just need to improve the text in the
draft so we have clarity. I suspect because puzzled me, it will
be harder for other people.

cheers,
jamal

---

From: "Joel M. Halpern" <[email-masked]>
Date: Wed, 17 Aug 2011 10:49:18 -0400

Yes, a good general rule.  If any of the folks who should know the stuff 
well are puzzled, then clarification is needed, since other folks are 
extremely likely to be puzzled.

Yours,
Joel

On 8/17/2011 10:43 AM, Jamal Hadi Salim wrote:
> 2011/8/17 Joel M. Halpern<[email-masked]>:

---

From: "Chuanhuang Li" <[email-masked]>
Date: Thu, 18 Aug 2011 10:39:22 +0800

Hi,Jamal and Weiming
    I just copied my previous email content. It can be added to section 5.4.2.1.
I think it is enough to specify this issue. Weiming can modify based on it.

5.4.2.1.  

   All associated metadata produced (but not consumed) by previous processed 
   LFBs should be delivered to CE via the ForCES protocol redirect message [RFC5810]. 
   CE can decide how to process the  packet according these metadata.
   For example, the packet can't find L2 information in EtherEncap and need to be 
   redirected to CE to do address resolution. Through the value of "ExecptionID" metadata, 
   CE knows what he should do. Of course, CE will be difficult to make a decision, if there 
   is no metadata indicating the status of the packet(such as ExecptionID). In this case, 
   CE should treat it as a new packet that havn't got any processing in FE.	

Yours,
Chuanhuang

======= 2011-08-17 17:07:51 Jamal Hadi Salim, wrote: =======

---

From: Jamal Hadi Salim <[email-masked]>
Date: Thu, 18 Aug 2011 08:14:23 -0400

Some small corrections below:

>   CE can decide how to process the  packet according these metadata.

Change last sentence to:
The CE can decide on how to process the redirected packet by referencing the
associated metadata.

>   CE should treat it as a new packet that havn't got any processing in FE.

As an example, a packet could be redirected by the FE to the CE because the
EtherEncap LFB is not able to resolve L2 information. The metadata
"ExceptionID",
created by the EtherEncap LFB is passed along with the packet and should be
sufficient for the CE to do the necessary processing and resolve the
L2 entry required.

cheers,
jamal

---

From: "Wang,Weiming" <[email-masked]>
Date: Thu, 1 Sep 2011 08:26:30 +0800

Jamal,

By refering your this comment, I again modified the 5.4.2.1 last paragraph as below: 

 All associated metadata produced (but not consumed) by previous processed LFBs should be delivered to CE via the ForCES protocol redirect message [RFC5810]. The CE can decide on how to process the redirected packet by referencing the associated metadata. As an example, a packet could be redirected by the FE to the CE because the EtherEncap LFB is not able to resolve L2 information. The metadata "ExceptionID", created by the EtherEncap LFB is passed along with the packet and should be sufficient for the CE to do the necessary processing and resolve the L2 entry required. 

By now, I suppose this comment can be closed.

thanks,

Weiming

----- Original Message ----- 
From: "Jamal Hadi Salim" <[email-masked]>
Subject: Re: comments #13

Change last sentence to:

cheers,
jamal